module Fuel
  module CLI
    module GerritCommon
      def fetch_change_id_or_fail
        change_id = commit_message =~ /Change-Id: (.*)/ && $1
        change_id or raise Thor::Error, set_color("No appropriate commit found at HEAD", :red)
      end

      def gerrit_url
        Fuel::Util::Config.get('gerrit', 'url').chomp('/')
      end

      def gerrit_ref(result)
        current_rev = result['current_revision']
        result['revisions'][current_rev]['fetch']['ssh']['ref']
      end

      def changes_endpoint(change_id = nil, path = nil)
        url = "#{gerrit_url}/a/changes/"
        url += "#{change_id}/" if change_id
        url += path if path
        url
      end
    end
  end
end